#include <iostream>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n;
    cin >> n;

    int a[n], bitovi[32] = {};
    for(int i = 0; i < n; i++) {
        cin >> a[i];
        int broj = a[i];
        for(int j = 0; j < 32; j++) {
            bitovi[j] += broj & 1;
            broj >>= 1;
        }
    }

    int q;
    cin >> q;
    for(int i = 0; i < q; i++) {
        int t;
        cin >> t;
        if(t == 0) {
            int k, c = 0;
            cin >> k;
            for(int j = 0; j < 32; j++)
                if(bitovi[j] - k + 1 > 0)
                    c += 1 << j;
            cout << c << '\n';
        }else{
            int k, x;
            cin >> k >> x;
            int broj = a[k-1];
            for(int j = 0; j < 32; j++) {
                bitovi[j] -= broj & 1;
                broj >>= 1;
            }
            a[k-1] = x;
            for(int j = 0; j < 32; j++) {
                bitovi[j] += x & 1;
                x >>= 1;
            }
        }
    }

    return 0;
}